package com.fanruan.api.design.chart;

import com.fr.design.chart.fun.impl.AbstractChartTypeUI;
import com.fr.design.gui.frpane.AttributeChangeListener;

/**
 * @author Bjorn
 * @version 10.0
 * Created by Bjorn on 2019-09-19
 */
public abstract class BaseChartTypeUI extends AbstractChartTypeUI {

    /**
     * 定义图表类型选择界面
     *
     * @return 类型选择界面
     */
    @Override
    public DefaultTypePane getPlotTypePane() {
        return new DefaultTypePane();
    }

    /**
     * 定义图表数据配置界面
     *
     * @return 数据配置界面
     */
    @Override
    public abstract BaseDataPane getChartDataPane(AttributeChangeListener listener);

    /**
     * 定义其他界面
     *
     * @return 其他界面集合
     */
    @Override
    public abstract BaseOtherPane[] getAttrPaneArray(AttributeChangeListener listener);

    /**
     * 定义图表类型选择界面子类型的名称
     *
     * @return 图表子类型名称集合
     */
    @Override
    public String[] getSubName() {
       return super.getSubName();
    }

    /**
     * 定义图表的icon图片路径
     *
     * @return icon图片路径
     */
    @Override
    public abstract String getIconPath();

    /**
     * 定义图表图表类型选择界面的类型名称
     *
     * @return 图表类型名称
     */
    @Override
    public abstract String getName();

    /**
     * 定义图表类型选择界面子类型的示例图片路径
     *
     * @return 图表子类型图片路径集合
     */
    @Override
    public abstract String[] getDemoImagePath();
}
