package com.fanruan.api.design.ui.component.chart;

import com.fanruan.api.design.ui.component.UIComboBox;
import com.fr.data.util.function.DataFunction;
import com.fr.design.i18n.Toolkit;
import com.fr.log.FineLoggerFactory;

/**
 * @author Bjorn
 * @version 10.0
 * Created by Bjorn on 2019-09-23
 */
public class CalculateComboBox extends UIComboBox {

    private static String[] functionName = initItem();

    private static String[] initItem() {
        String[] functionLocaleNames = DataFunctionType.getFunctionLocaleNames();
        for (int i = 0; i < functionLocaleNames.length; i++) {
            functionLocaleNames[i] = Toolkit.i18nText(functionLocaleNames[i]);
        }
        return functionLocaleNames;
    }

    public CalculateComboBox() {
        super(functionName);
        setSelectedIndex(0);
    }

    public void reset() {
        this.setSelectedItem(0);
    }

    /**
     * 通过公式对象，更新界面的公式选择
     */
    public void populateBean(DataFunction function) {
        int index = DataFunctionType.getIndexByFunction(function);
        if (index > 0) {
            this.setSelectedIndex(index);
        }
    }

    /**
     * 根据界面选择的公式，返回公式对象
     */
    public DataFunction updateBean() {
        try {
            int selectIndex = getSelectedIndex();
            DataFunction functionByIndex = DataFunctionType.getFunctionByIndex(selectIndex);
            return functionByIndex;
        } catch (InstantiationException e) {
            FineLoggerFactory.getLogger().error("Function Error");
        } catch (IllegalAccessException e) {
            FineLoggerFactory.getLogger().error("Function Error");
        }
        return null;
    }
}
