package com.fanruan.api.report.chart;

import com.fr.chart.impl.AbstractChartType;

/**
 * @author Bjorn
 * @version 10.0
 * Created by Bjorn on 2019-09-17
 */
public abstract class BaseChartType extends AbstractChartType {

    /**
     * 该种图表所有的图表对象实例，比如柱形图就有堆积柱形图，百分比堆积柱形图等等
     *
     * @return 图表所有的对象实例
     */
    @Override
    public abstract BaseChartWithData[] getChartTypes();

    /**
     * 图表在web端展现时需要的JS文件路径
     *
     * @return JS文件路径数组
     */
    @Override
    public abstract String[] getRequiredJS();

    /**
     * 图表在web端展现时需要的CSS文件路径
     *
     * @return CSS文件路径数组
     */
    @Override
    public abstract String[] getRequiredCss();

    /**
     * JS对象名，该对象一般是一个函数，执行后会在给定的dom中绘制图表
     *
     * @return JS对象名
     */
    @Override
    public abstract String getWrapperName();
}
