package com.fanruan.api.report.chart;

import com.fanruan.api.report.chart.field.BaseColumnFieldCollection;
import com.fr.base.chart.cross.FormulaProcessor;
import com.fr.chart.ChartWebPara;
import com.fr.chart.impl.AbstractChartWithData;
import com.fr.js.NameJavaScriptGroup;
import com.fr.json.JSONObject;

import java.awt.Image;

/**
 * @author Bjorn
 * @version 10.0
 * Created by Bjorn on 2019-09-17
 */
public abstract class BaseChartWithData extends AbstractChartWithData {

    /**
     * 获取所有的超链
     *
     * @return 超链集合
     */
    @Override
    public NameJavaScriptGroup getHotHyperlink(String linkKey) {
        return super.getHotHyperlink(linkKey);
    }

    /**
     * 处理公式，调用formulaProcessor.dealWith方法，覆写该方法需要调用父类的方法。
     */
    @Override
    public void dealFormula(FormulaProcessor formulaProcessor) {
        super.dealFormula(formulaProcessor);
    }

    /**
     * 生成设计器中显示的图片，默认返回一个饼图的图片
     *
     * @return 图片
     */
    @Override
    public Image toImage(int width, int height, int resolution, ChartWebPara chartWebPara) {
        return super.toImage(width, height, resolution, chartWebPara);
    }

    /**
     * 生成图表预览的options
     *
     * @return JSON对象
     */
    @Override
    public abstract JSONObject createAttributeConfig(ChartWebPara chartWebPara);

    /**
     * 定义图表的ID，与plugin.xml中的chartID对应
     *
     * @return ID
     */
    @Override
    public abstract String getID();

    /**
     * 获取字段集合对象
     *
     * @return 字段集合对象
     */
    public <T extends BaseColumnFieldCollection> T getColumnFieldCollection(Class<T> var1) {
        return super.getFieldCollection(var1);
    }
}
